/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __conversion__
#define __conversion__

typedef double (*PFconversion)(int,int,int);

extern PFconversion* changer_espace(int);

#define RGB 0
#define I1I2I3 1
#define LUV 2
#define YIQ 3
#define K1K2K3 4

#define ILLUMINANT_C

#ifdef ILLUMINANT_C
/*--------------------------------*/
/* Illuminant C */
/*--------------------------------*/
#define Xr 0.166
#define Yr 0.06
#define Zr 0.0

#define Xg 0.174
#define Yg 0.587
#define Zg 0.066

#define Xb 0.093
#define Yb 0.005
#define Zb 0.46

#define Xw 98.04
#define Yw 100.0
#define Zw 118.10
#define Uw 0.2009
#define Vw 0.4609

#define Rx 6.686
#define Ry -1.832
#define Rz -1.332

#define Gx -0.684
#define Gy 1.893
#define Gz 0.118

#define Bx 0.098
#define By -0.272
#define Bz 2.157
#endif

#ifdef ILLUMINANT_E
/*--------------------------------*/
/* Illuminant E                   */
/*--------------------------------*/
#define Xr 2.769
#define Yr 1.0
#define Zr 0.0

#define Xg 1.7518
#define Yg 4.5907
#define Zg 0.0565

#define Xb 1.133
#define Yb 0.0601
#define Zb 5.5943

#define Xw 100.0
#define Yw 100.0
#define Zw 100.0
#define Uw 0.2105
#define Vw 0.4737
#endif

#ifdef ILLUMINANT_D65
/*--------------------------------*/
/* Illuminant D65                 */
/*--------------------------------*/
#define Xr 0.478
#define Yr 0.263
#define Zr 0.02

#define Xg 0.299 
#define Yg 0.655 
#define Zg 0.16  

#define Xb 0.175
#define Yb 0.081 
#define Zb 0.908 

#define Xw 95.02
#define Yw 100.0
#define Zw 108.81
#define Uw 0.1978
#define Vw 0.4683


#endif

#ifdef ILLUMINANT_A
/*--------------------------------*/
/* Illuminant A                  */
/*--------------------------------*/
#define Xr 0.892
#define Yr 0.322
#define Zr 0.00

#define Xg 0.33  
#define Yg 0.863 
#define Zg 0.011

#define Xb 0.083
#define Yb 0.004  
#define Zb 0.409 

#define Xw 109.83
#define Yw 100.0
#define Zw 35.55 
#define Uw 0.2560
#define Vw 0.5243
#endif

#endif









