/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "conversion.h"
#include "types.h"
#include <math.h>

/****************************************************************************/
/* Ce fichier contient uniquement des fonctions auxilieres utilisees */
/* par les fonctions de conversion du fichier conversion.c */
/****************************************************************************/
void RGB_to_XYZ(int R,int G,int B,double *X,double*Y,double*Z)
{
    
   *X = Xr*R + Xg*G + Xb*B;
   *Y = Yr*R + Yg*G + Yb*B;
   *Z = Zr*R + Zg*G + Zb*B;

}
double RGB_to_xYz(int R,int G,int B)
{
    double retour;

    retour = Yr*R + Yg*G + Yb*B;
    
    return(retour);
}

double RGB_to_Luv(int R,int G,int B)
{
    double Y = RGB_to_xYz(R,G,B);
    double YparYw = Y/Yw;
    double retour;
    
    if(YparYw < 0.01)
	    retour = 903.3*YparYw;
    else
	    retour = 116.0*cbrt(YparYw) -16.0;

    return(retour);
}







