/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __IMAGE_DIST_H__
#define __IMAGE_DIST_H__

#include <classe.h>
#include <image.h>
#include <dart_list.h>
#include <type_obj.h>

CLASSE(image_dist);

/* Allocation, deallocation */
extern image_dist FAIRE_image_dist();
extern void      DEFAIRE_image_dist(image_dist);

/* Initialisations */
extern void  image_dist_initialize             (image_dist,
						int,
						int,
						double*,
						int,
						bouleen);
extern void  image_dist_set_adjacency_graph    (image_dist);

/* Requetes */
extern int       image_dist_give_cell_nb       (image_dist,int,int);
extern image     image_dist_give_image         (image_dist);
extern dart_list image_dist_give_adjacent_cells(image_dist,int);
extern bouleen   image_dist_is_point_frontier  (image_dist,int,int);
/* Fonctions de traage */
extern float  image_dist_mean_cardinal_of_delaunay_graph(image_dist);
#endif





