/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef DART_LIST_H
#define DART_LIST_H

#include "type_obj.h"
#include  "objet.h"
#include "classe.h"

CLASSE(dart_list);

#define NULL_DART_LIST  (dart_list)NULL

/* A utiliser au debut et en fin de prgr */
extern void      ALLOC_dart_list();
extern void      DEALLOC_dart_list();
/* A utiliser a chaque nouvelle instanciation d'objet */
extern dart_list FAIRE_dart_list();
extern void      DEFAIRE_dart_list(dart_list);

extern void      dart_list_reinitialize(dart_list);
extern int       dart_list_give_cardinal(dart_list);

extern dart_list dart_list_concat(dart_list, dart_list);

extern dart_list dart_list_copy(dart_list);

extern void      dart_list_insert_list(dart_list, dart_list);
extern void      dart_list_merge_list(dart_list, dart_list);
extern dart_list dart_list_intersection(dart_list, dart_list);

extern bouleen   dart_list_is_in(dart_list, dart);
extern bouleen   dart_list_is_empty(dart_list);

extern void      dart_list_first(dart_list);
extern void      dart_list_last(dart_list);
extern dart      dart_list_give_current(dart_list);
extern bouleen   dart_list_next(dart_list);
extern bouleen   dart_list_previous(dart_list);

extern void      dart_list_insert(dart_list, dart);
extern void      dart_list_remove_list(dart_list, dart_list);
extern bouleen   dart_list_remove_elt(dart_list, dart);
extern void      dart_list_print(dart_list);

#endif /* DART_LIST_H */


