/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include <assert.h>

#include "objet.h"
#include "garbage.h"
#include "list_gen.h"

#define List_object SELF(list_object)

struct garbage
{
  list_gen list_object;
};

garbage FAIRE_garbage()
{
  INSTANCIER(garbage);
  
  List_object = FAIRE_list_gen();

  return self;
}

void DEFAIRE_garbage(garbage self,void (*del)(any_ptr))
{
  assert(self);
  assert(del);

  DEFAIRE_list_gen(List_object,del);
  free(self);
}
void garbage_insert_object(garbage self,any_ptr obj)
{
  assert(self);

  list_gen_insert(List_object,obj);
}
any_ptr garbage_give_object(garbage self)
{
  any_ptr obj;

  assert(self);

  list_gen_first(List_object);
  obj = list_gen_give_current(List_object);
  list_gen_remove_current(List_object);

  return obj;
}
bouleen garbage_is_empty(garbage self)
{
  assert(self);
  return list_gen_give_cardinal(List_object) == 0;
}
    
