/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "point.h"

#include "objet.h"

#define X SELF(coordx)
#define Y SELF(coordy)

void modify_point_position(point p,move_type move_val)
{
  switch (move_val)
    {
    case RIGHT:
      MOVE_RIGHT_POINT(*p);
      break;
    case UP:
      MOVE_UP_POINT(*p);
      break;
    case LEFT:
      MOVE_LEFT_POINT(*p);
      break;
    case DOWN:
      MOVE_DOWN_POINT(*p);
      break;
    default :
      p->coordx = INFINITE;
      p->coordy = INFINITE;
      break;
    }

}

void point_affiche(point self)
{
  if(self == NULL) return;
  
  printf("(%d,%d)",X,Y);
}
/* Etant donne un point d'un segment demis entier donne le point */
/* entier correspondant  a l'interieur de la face */
/* On choisi le pixel en haut a droite du point un demis pour les */
/* debuts de ligne. Une autre convention aurait ete possible. Prendre */
/* par exemple les points en bas a gauche*/ 
void point_translate(point self,
		     point p,
		     move_type prec_move,
		     move_type next_move)
{
    
  static int move_x[4][4] =
    {/*     R U L D */
/*R*/      {0,1,0,0},
/*U*/      {0,1,0,0},
/*L*/      {0,1,0,0},
/*D*/      {0,0,0,0}
    };
  static int move_y[4][4] =
    {/*      R U L D */
/*R*/       {0,0,0,1},
/*U*/       {0,0,0,0},
/*L*/       {0,0,0,1},
/*D*/       {0,0,0,1}
    };
  COORDX(*p) = X + move_x[prec_move][next_move];
  COORDY(*p) = Y + move_y[prec_move][next_move];
}
void point_give_adjacents(point self,
			  move_type move,
			  point pts_entier)
{
  
  switch(move)
    {
    case RIGHT:
      COORDX(pts_entier[0]) = X+1;
      COORDY(pts_entier[0]) = Y;

      COORDX(pts_entier[1]) = X+1;
      COORDY(pts_entier[1]) = Y+1;
      break;

    case UP:
      COORDX(pts_entier[0]) = X;
      COORDY(pts_entier[0]) = Y;

      COORDX(pts_entier[1]) = X+1;
      COORDY(pts_entier[1]) = Y;
      break;
    case LEFT:
      COORDX(pts_entier[0]) = X;
      COORDY(pts_entier[0]) = Y;

      COORDX(pts_entier[1]) = X;
      COORDY(pts_entier[1]) = Y+1;
      break;
    
    case DOWN:
      COORDX(pts_entier[0]) = X;
      COORDY(pts_entier[0]) = Y+1;

      COORDX(pts_entier[1]) = X+1;
      COORDY(pts_entier[1]) = Y+1;
      break;
    }
}
void point_give_right_point(point self,move_type move,point p_right)
{
  static int dep_right[NB_MOVE][2] = 
    {
      {1,1},  /*R*/
      {1,0}, /*U*/
      {0,0},/*L*/
      {0,1}/*D*/
    };
  
  COORDX(*p_right) = X + dep_right[move][0];
  COORDY(*p_right) = Y + dep_right[move][1];
}
/* Etant donne 2 point entiers adjacents donne un point p1/2 et un move  */
void  point_give_p_1_2(point p_entier_1,
		       point p_entier_2,
		       point p_1_2,
		       angle *sep)
{
  int x1,y1,x2,y2;
  
  x1 = COORDX(*p_entier_1);
  x2 = COORDX(*p_entier_2);

  if(x1==x2)
    {
      y1 = COORDY(*p_entier_1);
      y2 = COORDY(*p_entier_2);
      *sep = LEFT_NEIGHBOUR;
      if(y1>y2)
	{
	  AFFECTE_POINT(*p_1_2,*p_entier_2);
	}
      else
	{
	  AFFECTE_POINT(*p_1_2,*p_entier_1);
	}
    }
  else
    {
      *sep = UP_NEIGHBOUR;
      if(x1>x2)
	{
	  AFFECTE_POINT(*p_1_2,*p_entier_2);
	}
      else
	{
	  AFFECTE_POINT(*p_1_2,*p_entier_1);
	}
    }
}
