/* inverse_brun
 *  Copyright (C) 2000 Luc Brun
 *  email: brun@leri.univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __VECT_PROPRE_H__
#define __VECT_PROPRE_H__

#include <image.h>
#include "vect.h"
#include "types.h"
#include "covariance.h"
#include "macros.h"
#include "image_dist.h"

extern void deux_premiers_vecteurs_propres(mat_passage,
					   vecteur,
					   vecteur);

extern void compute_max_min_proj(image,
				 vecteur,
				 vecteur,
				 double *,double*,
				 double*,double*);

extern double *projection_table(image,
				vecteur,
				vecteur,
				double,
				double);

extern image inverse_colormap(image,
			      image_dist,
			      image,
			      vecteur,
			      double,
			      vecteur,
			      double);

extern image improved_inverse_colormap(image,
				       image_dist,
				       image,
				       vecteur,
				       double,
				       vecteur,
				       double);

extern image slightly_improved_inverse_colormap(image,
						image_dist,
						image,
						vecteur,
						double,
						vecteur,
						double);






#endif
